#!/bin/python
##############################################################
#    Yasuko Matsubara 
#    Date: August, 2014
##############################################################
import sys
import pylab
import matplotlib.pyplot as plt
import numpy as np
ZERO = 0.00000000001
INF  = 1000000000000

####################
# math, etc.
####################
def log_s(x):
    return 2.0*np.log2(x)+1.0;
#######################
# tools for time series  
#######################
#-----------------------------#
# input: X[d][n]    d-dim seq
#        wd:        window-size
# output: Y[d][n]   smooth seq
#-----------------------------#
def smoothMA(X, wd):
    wd = int(wd)
    if(wd==1):
        return X
    # X[d][n]
    d=len(X)
    n=len(X[0])
    Y = np.zeros((d,n))
    for i in range(0,d):
        Y[i] = np.convolve(X[i], np.ones(wd)/wd, mode='same')
    return Y
#-----------------------------#
# input: X[d][n]    d-dim seq
#        wd:        window-size
# output: Y[d][int(n/wd)]   smooth seq
#-----------------------------#
def smoother(X, wd):
    wd = int(wd)
    if(wd==1):
        return X
    # X[d][n]
    d=len(X)
    n=len(X[0])
    n2=int(n/wd)
    Y = np.zeros((d,n2))
    for i in range(0,d):
        for j in range(0,n2):
            sum=0
            for w in range(0,wd):
               sum+=X[i][j*wd+w] 
            Y[i][j]=sum
    return Y
        
#-----------------------------#
# input:  X[a][b]    
# output: Y[a][b]   normalized seq
#-----------------------------#
def normalize01(X, a, b):
    Y = np.zeros((a,b))
    for i in range(0,a):
        xmax=0;xmin=INF;
        for j in range(0,b):
            val = X[i][j]
            if(xmax < val): xmax=val
            if(xmin > val): xmin=val
        for j in range(0,b):
            Y[i][j] = (X[i][j]-xmin)/(xmax-xmin+ZERO)
    return Y
# without min
def normalizeM(X, a, b):
    Y = np.zeros((a,b))
    for i in range(0,a):
        xmax = 0
        for j in range(0,b):
            val = abs(X[i][j])
            if(xmax < val):
                xmax=val
        for j in range(0,b):
            Y[i][j] = X[i][j]/(xmax+ZERO)
    return Y


####################
# display
####################
def error(msg):
    print "===================="
    print " error              "
    print "--------------------"
    print "%s"%msg
    print "===================="
    #raise
    sys.exit(0);
def warning(msg):
    print "*** Warning *** : %s"%msg
def dotting(dot='.'):
    sys.stdout.write(dot)
    sys.stdout.flush()
def comment(msg):
    print "--------------------"
    print " %s"%msg
    print "--------------------"
def notfin():
    print "--------------------"
    print " NOT FIN "
    print "--------------------"
def figure(fid):
    plt.figure(fid) 
    plt.ion(); pylab.cla();
    plt.subplot(111)
    #plt.draw(); 

